
import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.event.*;
import java.util.*;
import Listes.*;
import Fichiers.*;
import java.io.*;
import java.net.*;
import javax.imageio.*;

public  class FenetreTortue extends JFrame{
    // Numro de version
    
    public final double INFINI = Double.POSITIVE_INFINITY;
    private final String version = "3.0";
    private final int entMin = -2147483648;
    private final double decMin = -1.7*Math.pow(10, 308);

    // Dfinir des constantes "comprhensibles" pour les couleurs
    protected Color noir        = Color.black;
    protected Color bleu        = Color.blue;
    protected Color cyan        = Color.cyan;
    protected Color grisFonce   = Color.darkGray;
    protected Color gris        = Color.gray;
    protected Color vert        = Color.green;
    protected Color grisClair   = Color.lightGray;
    protected Color magenta     = Color.magenta;
    protected Color orange      = Color.orange;
    protected Color rose        = Color.pink;
    protected Color rouge       = Color.red;
    protected Color blanc       = Color.white;
    protected Color jaune       = Color.yellow;
    // retour de chariot
    protected final String chariot = "\n";
    // la zone graphique
    private FeuilleADessin f;
    // La zone de texte
    private JTextArea texte = new JTextArea();
    // Le contenant des zones graphiques et texte
    JSplitPane front = null;
    // La tortue
    private Tortue tortueCourante;
    // ???
    protected static int MAX_BOUTONS = 16;
    // La liste des boutons
    private ArrayList lesBoutons = new ArrayList();
    public ArrayList lesChamps = new ArrayList();
    // La liste des lignes de rgles
    private static ArrayList[] regles = {new ArrayList(), new ArrayList()};
    // La liste des rgles dans l'ordre naturel
    private static ArrayList lesRegles = new ArrayList();
    private ArrayList lesGlissieres;
    private JMenuItem[][] menusItems;
    
    private EcouteurSouris ec;
    private EcouteurFenetre ecf;
    
    private boolean _boutonSpecial = false;
    private boolean _interruptionPermise;
    
    private boolean demandeAnnulation = false;
    
    // Des constantes
    private final int tailleImage = 2048;
    public final int entier =1;
    public final int decimal =2;
    public final int chaine =3;
    public final int booleen = 4;
    public final int liste =5;
    
    private boolean boutonSouris = false;
    private int sourisX = 0;
    private int sourisY = 0;
    
    private InOut fichiers;
    
    private ArrayList _processus = new ArrayList();
    private static boolean pourApplet = false;
    private boolean pret = false;
    
    
    /* Cration de la fentre */
    
    public FenetreTortue(int l, int h, String titre, String[] nomsBoutons1, 
                        String[] nomsBoutons2, String[] nomsChamps1, String[] nomsChamps2, String[][] lesMenus, boolean avecTexte){
        
        f = new FeuilleADessin();
        f.setSize(200, 200);
        f.setBackground(Color.white);
        f.addMouseMotionListener(ec = new EcouteurSouris());
        f.addMouseListener(ec);
        f.addComponentListener(ecf = new EcouteurFenetre());
        tortueCourante = new Tortue(f);
        // Cration de l'interface graphique avec ou sans texte, boutons sur 0, 1 ou 2 lignes
        JComponent facade = creerFacade(avecTexte, nomsBoutons1, nomsBoutons2, nomsChamps1, nomsChamps2);
        Container c = getContentPane();
        c.add(facade, BorderLayout.CENTER);
        // Ajout des regles
        JPanel regles = creerPanneauRegles();
        if (regles != null){
            c.add(regles, BorderLayout.NORTH);
        }
        lesGlissieres = new ArrayList();
        for (int i = 0; i< lesRegles.size(); i++){
            lesGlissieres.add(lesRegles.get(i)); // L'ordre est prserv
        }
        initGlissieres();
        // Cration des menus
        CreerMenus(lesMenus);
        c.setBackground(Color.white);
        addWindowListener(new fermerFenetre());
        
        fichiers = new InOut(c);
        
        setTitle(titre);
        setSize(l, h);
        setVisible(true); // peut-tre simplement pack() avec setVisible  la fin?
        
        fixeOrigineTortue(largeurZoneGraphique()/2, hauteurZoneGraphique()/2);
        
        f.imgTampon = new BufferedImage(tailleImage, tailleImage, BufferedImage.TYPE_INT_ARGB);
        f.gTampon = (Graphics2D) f.imgTampon.getGraphics();
        f.gTampon.setPaint(Color.white);
        f.gTampon.fillRect(0, 0, tailleImage, tailleImage);
        
        _interruptionPermise = false;
        pourApplet = false; 
        pret = true;
    }
    
    public FenetreTortue(int l, int h, String titre, String[] nomsBoutons1, 
                        String[] nomsBoutons2, String[][] lesMenus, boolean avecTexte){
        
        f = new FeuilleADessin();
        f.setSize(200, 200);
        f.setBackground(Color.white);
        f.addMouseMotionListener(ec = new EcouteurSouris());
        f.addMouseListener(ec);
        f.addComponentListener(ecf = new EcouteurFenetre());
        tortueCourante = new Tortue(f);
        // Cration de l'interface graphique avec ou sans texte, boutons sur 0, 1 ou 2 lignes
        JComponent facade = creerFacade(avecTexte, nomsBoutons1, nomsBoutons2);
        Container c = getContentPane();
        c.add(facade, BorderLayout.CENTER);
        // Ajout des regles
        JPanel regles = creerPanneauRegles();
        if (regles != null){
            c.add(regles, BorderLayout.NORTH);
        }
        lesGlissieres = new ArrayList();
        for (int i = 0; i< lesRegles.size(); i++){
            lesGlissieres.add(lesRegles.get(i)); // L'ordre est prserv
        }
        initGlissieres();
        // Cration des menus
        CreerMenus(lesMenus);
        c.setBackground(Color.white);
        addWindowListener(new fermerFenetre());
        
        fichiers = new InOut(c);
        
        setTitle(titre);
        setSize(l, h);
        setVisible(true); // peut-tre simplement pack() avec setVisible  la fin?
        
        fixeOrigineTortue(largeurZoneGraphique()/2, hauteurZoneGraphique()/2);
        
        f.imgTampon = new BufferedImage(tailleImage, tailleImage, BufferedImage.TYPE_INT_ARGB);
        f.gTampon = (Graphics2D) f.imgTampon.getGraphics();
        f.gTampon.setPaint(Color.white);
        f.gTampon.fillRect(0, 0, tailleImage, tailleImage);
        
        _interruptionPermise = false;
        pourApplet = false; 
        pret = true;
    }
    
    private JComponent creerFacade(boolean avecTexte, String[] nomsBoutons1, String[] nomsBoutons2, String[] nomsChamps1, String[] nomsChamps2){
        JPanel haut = new JPanel(new BorderLayout());
        haut.setBackground(Color.white);
        haut.add(f, BorderLayout.CENTER);
        // Cration d'un panneau pour les boutons
        JPanel panelBoutons = creerPanneauBoutons(nomsBoutons1, nomsBoutons2, nomsChamps1, nomsChamps2);
        // ajout du panneau de boutons au panneau
        if (panelBoutons != null){
            haut.add(panelBoutons, BorderLayout.SOUTH);
        }
        if (!avecTexte){return haut;}
        front = new JSplitPane();
        front.setOrientation(JSplitPane.VERTICAL_SPLIT);
        front.setDividerLocation(350);
        front.setTopComponent(haut);
        // Pour savoir si le texte est prsent on fera (texte != null);
        texte = new JTextArea();
        texte.setEditable(false);
        texte.setDisabledTextColor(Color.black);
        texte.setLineWrap(true);
        texte.setRows(1);
        // Barres de dfilement
        JScrollPane sp = new JScrollPane(texte);
        front.setBottomComponent(sp);
        
        return front;
    }
    
    private JComponent creerFacade(boolean avecTexte, String[] nomsBoutons1, String[] nomsBoutons2){
        JPanel haut = new JPanel(new BorderLayout());
        haut.setBackground(Color.white);
        haut.add(f, BorderLayout.CENTER);
        // Cration d'un panneau pour les boutons
        JPanel panelBoutons = creerPanneauBoutons(nomsBoutons1, nomsBoutons2);
        // ajout du panneau de boutons au panneau
        if (panelBoutons != null){
            haut.add(panelBoutons, BorderLayout.SOUTH);
        }
        if (!avecTexte){return haut;}
        front = new JSplitPane();
        front.setOrientation(JSplitPane.VERTICAL_SPLIT);
        front.setDividerLocation(350);
        front.setTopComponent(haut);
        // Pour savoir si le texte est prsent on fera (texte != null);
        texte = new JTextArea();
        texte.setEditable(false);
        texte.setDisabledTextColor(Color.black);
        texte.setLineWrap(true);
        texte.setRows(1);
        // Barres de dfilement
        JScrollPane sp = new JScrollPane(texte);
        front.setBottomComponent(sp);
        
        return front;
    }
    
    private void CreerMenus(String[][] lesMenus) {
        if (estVide(lesMenus)) {return;}
        menusItems = new JMenuItem[8][8];   // tableau des items de menu
        for (int k = 0; k < 8; k++){        // Initialisation du tableau (automatique? :  voir)
            for(int l = 0; l < 8; l++){
                menusItems[k][l] = null;
            }
        }
        JMenuBar barre = new JMenuBar();
        for (int i=0; i<lesMenus.length; i++) {
            if (lesMenus[i].length == 0)
            {break;}
            else{
                JMenu menu;
                String nomMenu = lesMenus[i][0];
                String prefixe = nomMenu.substring(0,2);
                if (prefixe.equals("s_")){ // Cas des boutons radio
                    nomMenu = nomMenu.substring(2);
                    menu = new JMenu(nomMenu);
                    ButtonGroup leGroupe = new ButtonGroup();
                    for (int j=1; j<lesMenus[i].length; j++) {
                        JRadioButtonMenuItem item = new JRadioButtonMenuItem(lesMenus[i][j]);
                        item.addActionListener(new EcouteurMenus(10*i+j));
                        leGroupe.add(item);
                        menusItems[i][j-1] = item; // menu i+1 item j
                        menu.add(item);
                    }
                }else if (prefixe.equals("c_")){ // Cas de cases  cocher
                    nomMenu = nomMenu.substring(2);
                    menu = new JMenu(nomMenu);
                    for (int j=1; j<lesMenus[i].length; j++) {
                        JCheckBoxMenuItem item = new JCheckBoxMenuItem(lesMenus[i][j]);
                        item.addActionListener(new EcouteurMenus(10*i+j));
                        menusItems[i][j-1] = item; // menu i+1 item j
                        menu.add(item);
                    }
                }else{
                    menu = new JMenu(nomMenu);
                    for (int j=1; j<lesMenus[i].length; j++) {
                        JMenuItem item = new JMenuItem(lesMenus[i][j]);
                        item.addActionListener(new EcouteurMenus(10*i+j));
                        menusItems[i][j-1] = item; // menu i item j
                        menu.add(item);
                    }
                }
                barre.add(menu);
            }
        }
        setJMenuBar(barre);
    }
    
    public boolean etatMenuItem(int menu, int item){
        if ((menu < 1) | (menu > 8) | (item < 1) | (item > 8)){return false;}
        JMenuItem unItem = menusItems[menu-1][item-1];
        if (unItem instanceof JRadioButtonMenuItem){
            if (((JRadioButtonMenuItem) unItem).isSelected()){
                return true;
            }else{
                return false;
            }
        }else if (unItem instanceof JCheckBoxMenuItem){
            if (((JCheckBoxMenuItem) unItem).isSelected()){
                return true;
            }else{
                return false;
            }
        }
        return false;
    }
    
    public void selectionMenuItem(int menu, int item, boolean b){
        /*
         * Slectionne (ou dslectionne en fonction de b) l'item du menu concern 
         * si c'est possible, sinon ne fait rien.
         */
        if ((menu < 1) | (menu > 8) | (item < 1) | (item > 8)){return;}
        JMenuItem unItem = menusItems[menu-1][item-1];
        if (unItem instanceof JRadioButtonMenuItem){
            ((JRadioButtonMenuItem) unItem).setSelected(b);
        }else if (unItem instanceof JCheckBoxMenuItem){
            ((JCheckBoxMenuItem) unItem).setSelected(b); 
        }
    }
    
    public void changerNomItemMenu(int noMenu, int noItem, String nomItem) {
        menusItems[noMenu-1][noItem-1].setText(nomItem);
    }
    
    private boolean estVide(String [][] tableau){// Teste si un tableau  2 dim est vide
        for (int i = 0; i < tableau.length; i++){
            if (tableau[i].length != 0) {return false;}
        }
        return true;
    }
    
    private JPanel creerLigneBoutons(int debut, String[] nomsBoutons){
        if (nomsBoutons.length == 0){return null;}
        JPanel panelBoutons = new JPanel();
        panelBoutons.setBackground(Color.white);
        //panelBoutons.setBorder(BorderFactory.createLoweredBevelBorder());
        JButton b;
        for (int i = debut; i < nomsBoutons.length + debut && i < MAX_BOUTONS; i++){
            int k = i - debut;
            if ((nomsBoutons[k].length() > 12) && (nomsBoutons[k].substring(0, 13).equals( "Interruption_"))){
                b = new JButton(nomsBoutons[k].substring(13));
                b.addActionListener(new EcouteurBoutonSpecial(i));
            }else{
                b = new JButton(nomsBoutons[k]);
                b.addActionListener(new EcouteurBouton(i));
            }
            lesBoutons.add(b);
            panelBoutons.add(b);
        }
        return panelBoutons;
    }
    
    private JPanel creerLigneChamps(String[] nomsChamps){
        if (nomsChamps.length == 0){return null;}
        JPanel panelChamps = new JPanel();
        panelChamps.setBackground(Color.white);
        CTexte c;
        for (int i = 0; i < nomsChamps.length/2; i++){
            int nbCol;
            try {
                nbCol = Integer.parseInt(nomsChamps[2*i+1]);
            }catch (Exception e){
                nbCol = 5;
            }
            if (nbCol < 5){ nbCol = 5;}
            c = new CTexte(nbCol);
            lesChamps.add(c);
            JLabel legende = new JLabel(nomsChamps[2*i] + ": ", JLabel.CENTER);
            panelChamps.add(legende);
            panelChamps.add(c);
        }
        return panelChamps;
    }
    
    private JPanel creerPanneauBoutons(String[] nomsBoutons1, String[] nomsBoutons2, String[] nomsChamps1, String[] nomsChamps2){
        JPanel ligne1 = creerLigneBoutons(0, nomsBoutons1);
        JPanel ligne2 = creerLigneBoutons(nomsBoutons1.length, nomsBoutons2);
        JPanel ligne3 = creerLigneChamps(nomsChamps1);
        JPanel ligne4 = creerLigneChamps(nomsChamps2);
        
        int[] nbs = new int[4];
        for(int i = 0; i < nbs.length; i++){
            nbs[i] = 0;
        }
        
        if (ligne1 != null){nbs[0] = 1;}
        if (ligne2 != null){nbs[1] = 1;}
        if (ligne3 != null){nbs[2] = 1;}
        if (ligne4 != null){nbs[3] = 1;}
        
        int nbLignes = 0;
        for (int i = 0; i< nbs.length; i++){
            nbLignes += nbs[i];
        }
        
        if (nbLignes == 0){ return null;}
        
        JPanel panneau = new JPanel(new GridLayout(nbLignes, 1));
        
        if (nbs[0] == 1){ panneau.add(ligne1);}
        if (nbs[1] == 1){ panneau.add(ligne2);}
        if (nbs[2] == 1){ panneau.add(ligne3);}
        if (nbs[3] == 1){ panneau.add(ligne4);}
        
        panneau.setBorder(BorderFactory.createLoweredBevelBorder());
        return panneau;
    }
    
    private JPanel creerPanneauBoutons(String[] nomsBoutons1, String[] nomsBoutons2){
        JPanel ligne1 = creerLigneBoutons(0, nomsBoutons1);
        JPanel ligne2 = creerLigneBoutons(nomsBoutons1.length, nomsBoutons2);
        if (ligne1 == null && ligne2 == null){return null;}
        if (ligne1 == null) {
            ligne2.setBorder(BorderFactory.createLoweredBevelBorder());
            return ligne2;
        }
        if (ligne2 == null) {
            ligne1.setBorder(BorderFactory.createLoweredBevelBorder());
            return ligne1;
        }
        JPanel panneau = new JPanel(new GridLayout(2, 1));
        panneau.add(ligne1);
        panneau.add(ligne2);
        panneau.setBorder(BorderFactory.createLoweredBevelBorder());
        return panneau;
    }
    
    public class fermerFenetre extends WindowAdapter{
        public void windowClosing(WindowEvent evt){
            evt.getWindow().dispose();
            System.exit(0);
        }
    }
/**************** Les rgles ******************************/    
    private static void creerRegle(int ligne, String legende, double debut, double fin, double posInit, int nbDec){
        Glissiere regle = new Glissiere(legende, debut, fin, posInit, nbDec);
        switch(ligne){
            case 1:
                regles[0].add(regle);
                break;
            case 2:
                regles[1].add(regle);
                break;
        }
    }
    
    private static void creerRegle(int ligne, String legende, double debut, double fin, double posInit){
        creerRegle(ligne, legende, debut, fin, posInit, 0);
    }
    
    private void executerRegle(int numero, double valeur){
        switch (numero){
            case 0:
                actionGlissiere1(valeur);
                break;
            case 1:
                actionGlissiere2(valeur);
                break;
            case 2:
                actionGlissiere3(valeur);
                break;
            case 3:
                actionGlissiere4(valeur);
                break;
            case 4:
                actionGlissiere5(valeur);
                break;
            case 5:
                actionGlissiere6(valeur);
                break;
            case 6:
                actionGlissiere7(valeur);
                break;
            case 7:
                actionGlissiere8(valeur);
                break;
            case 8:
                actionGlissiere9(valeur);
                break;
            case 9:
                actionGlissiere10(valeur);
                break;
            case 10:
                actionGlissiere11(valeur);
                break;
            case 11:
                actionGlissiere12(valeur);
                break;
        }
    }

    
    class EcouteurRegles implements ChangeListener{
        private int numero;
        
        public EcouteurRegles(int numero){
            this.numero = numero;
        }
        
        public void stateChanged(ChangeEvent e){
            JSlider laRegle = ((Glissiere)lesGlissieres.get(numero)).getSlider();
            double valeur = laRegle.getValue();
            int nbDec = ((Glissiere)lesGlissieres.get(numero)).getDecimales();
            if (nbDec > 0){
                int facteur = (int) Math.pow(10, nbDec);
                valeur /= facteur;
            }
            final double val = valeur;
            if (! _interruptionPermise){
                executerRegle(numero, valeur);
            }else{
                if (_processus.size() != 0){return;}
                SwingWorker processusRegle = new SwingWorker(_processus){
                    public Object construct(){
                        executerRegle(numero, val);
                        return null;
                    }// construct
                    
                    public void finished(){  
                        getProc().remove(0); // C'est lui-mme
                    }// finished
                };// SwingWorker
                if (_processus.size() == 1){ // test inutile mais...
                    processusRegle.start();
                }// if
            }// else
        }// StateChanged
    }
    
    private JPanel creerLigneRegles(int ligne){
        int debut = 0;
        if (ligne == 2){debut = regles[0].size();}
        int nbRegles = regles[ligne-1].size();
        if (nbRegles == 0){ return null;}
        JPanel pRegles = new JPanel(new GridLayout(1, 6));
        if (nbRegles > 6){nbRegles = 6;}// maximum 2 regles!!
        for(int i = 0; i < nbRegles; i++){
            Glissiere regle = (Glissiere)regles[ligne - 1].get(i);
            EcouteurRegles er = new EcouteurRegles(debut + i);
            (regle.getSlider()).addChangeListener(er);
            pRegles.add(regle);
            lesRegles.add(regle);
        }
        return pRegles;
    }

    private JPanel creerPanneauRegles(){
        JPanel pRegles = new JPanel(new GridLayout(2, 1));
        JPanel ligne1 = creerLigneRegles(1);
        JPanel ligne2 = creerLigneRegles(2);
        if (ligne2 == null){
            if (ligne1 == null){
                return null;
            }else{
                return ligne1;
            }
        }else{
            if (ligne1 == null){
                return ligne2;
            }else{
                pRegles.add(ligne1);
                pRegles.add(ligne2);
            }
        }
        return pRegles;
    }

    public void actionGlissiere1(double a){}
    public void actionGlissiere2(double a){}
    public void actionGlissiere3(double a){}
    public void actionGlissiere4(double a){}
    public void actionGlissiere5(double a){}
    public void actionGlissiere6(double a){}
    public void actionGlissiere7(double a){}
    public void actionGlissiere8(double a){}
    public void actionGlissiere9(double a){}
    public void actionGlissiere10(double a){}
    public void actionGlissiere11(double a){}
    public void actionGlissiere12(double a){}
    
    protected double valeurGlissiere(int i){
        if (i < 1 || i > lesGlissieres.size()){
            System.out.println("Il n'y a pas de glissire numro " + i);
            return -1;
        }
        return ((Glissiere)lesGlissieres.get(i-1)).getValue();
    }
    
    protected void fixeValeurGlissiere(int i, double d){ 
        if (i < 1 || i > lesGlissieres.size()){
            System.out.println("Il n'y a pas de glissire numro " + i);
        }
        ((Glissiere)lesGlissieres.get(i-1)).setValue(d);
    }
    
    // **************** Ajout de glissires *******************

    public static void ajouterGlissiereLigne1(String legende, double debut, double fin, double posInit, int nbDec){
        int nb = regles[0].size();
        if(nb > 6){
            System.out.println("Il y a dej 6 rgles sur la ligne 1!");
            return;
        }
        creerRegle(1, legende, debut, fin, posInit, nbDec);
    }
    
    public static void ajouterGlissiereLigne1(String legende, double debut, double fin){
        ajouterGlissiereLigne1(legende, debut, fin, debut, 0);
    }
    
    public static void ajouterGlissiereLigne2(String legende, double debut, double fin, double posInit, int nbDec){
        int nb = regles[1].size();
        if(nb > 6){
            System.out.println("Il y a dej 6 rgles sur la ligne 2!");
            return;
        }
        creerRegle(2, legende, debut, fin, posInit, nbDec);
    }
    
    public static void ajouterGlissiereLigne2(String legende, double debut, double fin){
        ajouterGlissiereLigne2(legende, debut, fin, debut, 0);
    }
    
    public static void initGlissieres(){   
        regles[0].clear();   
        regles[1].clear();
        lesRegles.clear(); 
    }
/**************** Les menus ****************************/

    public void executerMenu(int type){
        switch(type){
            case 1:
                actionMenu1Item1();
                break;
            case 2:
                actionMenu1Item2();
                break;
            case 3:
                actionMenu1Item3();
                break;
            case 4:
                actionMenu1Item4();
                break;
            case 5:
                actionMenu1Item5();
                break;
            case 6:
                actionMenu1Item6();
                break;
            case 7:
                actionMenu1Item7();
                break;
            case 8:
                actionMenu1Item8();
                break;
                
            case 11:
                actionMenu2Item1();
                break;
            case 12:
                actionMenu2Item2();
                break;
            case 13:
                actionMenu2Item3();
                break;
            case 14:
                actionMenu2Item4();
                break;
            case 15:
                actionMenu2Item5();
                break;
            case 16:
                actionMenu2Item6();
                break;
            case 17:
                actionMenu2Item7();
                break;
            case 18:
                actionMenu2Item8();
                break;
                
            case 21:
                actionMenu3Item1();
                break;
            case 22:
                actionMenu3Item2();
                break;
            case 23:
                actionMenu3Item3();
                break;
            case 24:
                actionMenu3Item4();
                break;
            case 25:
                actionMenu3Item5();
                break;
            case 26:
                actionMenu3Item6();
                break;
            case 27:
                actionMenu3Item7();
                break;
            case 28:
                actionMenu3Item8();
                break;
            
                
            case 31:
                actionMenu4Item1();
                break;
            case 32:
                actionMenu4Item2();
                break;
            case 33:
                actionMenu4Item3();
                break;
            case 34:
                actionMenu4Item4();
                break;
            case 35:
                actionMenu4Item5();
                break;
            case 36:
                actionMenu4Item6();
                break;
            case 37:
                actionMenu4Item7();
                break;
            case 38:
                actionMenu4Item8();
                break;
            
                
            case 41:
                actionMenu5Item1();
                break;
            case 42:
                actionMenu5Item2();
                break;
            case 43:
                actionMenu5Item3();
                break;
            case 44:
                actionMenu5Item4();
                break;
            case 45:
                actionMenu5Item5();
                break;
            case 46:
                actionMenu5Item6();
                break;
            case 47:
                actionMenu5Item7();
                break;
            case 48:
                actionMenu5Item8();
                break;
            
                
            case 51:
                actionMenu6Item1();
                break;
            case 52:
                actionMenu6Item2();
                break;
            case 53:
                actionMenu6Item3();
                break;
            case 54:
                actionMenu6Item4();
                break;
            case 55:
                actionMenu6Item5();
                break;
            case 56:
                actionMenu6Item6();
                break;
            case 57:
                actionMenu6Item7();
                break;
            case 58:
                actionMenu6Item8();
                break;
            
                
            case 61:
                actionMenu7Item1();
                break;
            case 62:
                actionMenu7Item2();
                break;
            case 63:
                actionMenu7Item3();
                break;
            case 64:
                actionMenu7Item4();
                break;
            case 65:
                actionMenu7Item5();
                break;
            case 66:
                actionMenu7Item6();
                break;
            case 67:
                actionMenu7Item7();
                break;
            case 68:
                actionMenu7Item8();
                break;
            
                
            case 71:
                actionMenu8Item1();
                break;
            case 72:
                actionMenu8Item2();
                break;
            case 73:
                actionMenu8Item3();
                break;
            case 74:
                actionMenu8Item4();
                break;
            case 75:
                actionMenu8Item5();
                break;
            case 76:
                actionMenu8Item6();
                break;
            case 77:
                actionMenu8Item7();
                break;
            case 78:
                actionMenu8Item8();
                break;
        }
    }
    
    class EcouteurMenus implements ActionListener{
        private int type;
        
        public EcouteurMenus(int type){
            this.type = type;
        }
        
        public void actionPerformed(ActionEvent e){
            if (! _interruptionPermise){
                executerMenu(type);
            }else{
                if (_processus.size() != 0){return;}
                SwingWorker processusMenu = new SwingWorker(_processus){
                    public Object construct(){
                        executerMenu(type);
                        return null;
                    }// construct
                    
                    public void finished(){  
                        getProc().remove(0); // C'est lui-mme
                    }// finished
                };// SwingWorker
                if (_processus.size() == 1){ // test inutile mais...
                    processusMenu.start();
                }
            }
        }// actionPerformed
    }
      
    protected void actionMenu1Item1(){};
    protected void actionMenu1Item2(){};
    protected void actionMenu1Item3(){};
    protected void actionMenu1Item4(){};
    protected void actionMenu1Item5(){};
    protected void actionMenu1Item6(){};
    protected void actionMenu1Item7(){};
    protected void actionMenu1Item8(){};
    
    protected void actionMenu2Item1(){};
    protected void actionMenu2Item2(){};
    protected void actionMenu2Item3(){};
    protected void actionMenu2Item4(){};
    protected void actionMenu2Item5(){};
    protected void actionMenu2Item6(){};
    protected void actionMenu2Item7(){};
    protected void actionMenu2Item8(){};
    
    protected void actionMenu3Item1(){};
    protected void actionMenu3Item2(){};
    protected void actionMenu3Item3(){};
    protected void actionMenu3Item4(){};
    protected void actionMenu3Item5(){};
    protected void actionMenu3Item6(){};
    protected void actionMenu3Item7(){};
    protected void actionMenu3Item8(){};
    
    protected void actionMenu4Item1(){};
    protected void actionMenu4Item2(){};
    protected void actionMenu4Item3(){};
    protected void actionMenu4Item4(){};
    protected void actionMenu4Item5(){};
    protected void actionMenu4Item6(){};
    protected void actionMenu4Item7(){};
    protected void actionMenu4Item8(){};
    
    protected void actionMenu5Item1(){};
    protected void actionMenu5Item2(){};
    protected void actionMenu5Item3(){};
    protected void actionMenu5Item4(){};
    protected void actionMenu5Item5(){};
    protected void actionMenu5Item6(){};
    protected void actionMenu5Item7(){};
    protected void actionMenu5Item8(){};
    
    protected void actionMenu6Item1(){};
    protected void actionMenu6Item2(){};
    protected void actionMenu6Item3(){};
    protected void actionMenu6Item4(){};
    protected void actionMenu6Item5(){};
    protected void actionMenu6Item6(){};
    protected void actionMenu6Item7(){};
    protected void actionMenu6Item8(){};
    
    protected void actionMenu7Item1(){};
    protected void actionMenu7Item2(){};
    protected void actionMenu7Item3(){};
    protected void actionMenu7Item4(){};
    protected void actionMenu7Item5(){};
    protected void actionMenu7Item6(){};
    protected void actionMenu7Item7(){};
    protected void actionMenu7Item8(){};
    
    protected void actionMenu8Item1(){};
    protected void actionMenu8Item2(){};
    protected void actionMenu8Item3(){};
    protected void actionMenu8Item4(){};
    protected void actionMenu8Item5(){};
    protected void actionMenu8Item6(){};
    protected void actionMenu8Item7(){};
    protected void actionMenu8Item8(){};
   
/********************* Les boutons *****************************/

    private void executerBouton(int numero){
            switch(numero){
                case 0:
                    actionBouton1();
                    break;
                case 1:
                    actionBouton2();
                    break;
                case 2:
                    actionBouton3();
                    break;
                case 3:
                    actionBouton4();
                    break;
                case 4:
                    actionBouton5();
                    break;
                case 5:
                    actionBouton6();
                    break;
                case 6:
                    actionBouton7();
                    break;
                case 7:
                    actionBouton8();
                    break;
                case 8:
                    actionBouton9();
                    break;
                case 9:
                    actionBouton10();
                    break;
                case 10:
                    actionBouton11();
                    break;
                case 11:
                    actionBouton12();
                    break;
                case 12:
                    actionBouton13();
                    break;
                case 13:
                    actionBouton14();
                    break;
                case 14:
                    actionBouton15();
                    break;
                case 15:
                    actionBouton16();
                    break;
            }// Switch
    }
    
    class EcouteurBouton implements ActionListener{
        private int type;
        
        public EcouteurBouton(int type){
            this.type = type;
        }
        
        public void actionPerformed(ActionEvent e){
            if (! _interruptionPermise){
                executerBouton(type);
            }else{
                if (_processus.size() != 0){return;}
                SwingWorker processusBouton = new SwingWorker(_processus){
                    public Object construct(){
                        executerBouton(type);
                        return null;
                    }// construct
                    
                    public void finished(){  
                        getProc().remove(0); // C'est lui-mme
                    }// finished
                };// SwingWorker
                if (_processus.size() == 1){ // test inutile mais...
                    processusBouton.start();
                }
            }
        }// actionPerformed
    }// class ecouteurBoutons
    
    class EcouteurBoutonSpecial implements ActionListener{
        private int type;
        
        public EcouteurBoutonSpecial(int type){
            this.type = type;
        }
        
        public void actionPerformed(ActionEvent e){
            if (_interruptionPermise){
                _boutonSpecial = true;
            }
        }// actionPerformed
    }// class ecouteurBoutons
    
    public boolean interruption(){
        if (_boutonSpecial){
            _boutonSpecial = false;
            return true;
        }
        return false;
    }
        
    public void changerNomBouton(int i, String nom){
        if (i < 1 || i > lesBoutons.size()){
            System.out.println("Problme dans 'changerNomBouton' :");
            System.out.println("Il n'y a pas de bouton  numro " + i);
            return;
        }
        ((JButton)lesBoutons.get(i-1)).setText(nom);
    }
    
    public void activerBouton(int i){
        if (i < 1 || i > lesBoutons.size()){
            System.out.println("Problme dans 'activerBouton' :");
            System.out.println("Il n'y a pas de bouton  numro " + i);
            return;
        }
        ((JButton)lesBoutons.get(i-1)).setEnabled(true);
    }
    public void desactiverBouton(int i){
        if (i < 1 || i > lesBoutons.size()){
            System.out.println("Problme dans 'desactiverBouton' :");
            System.out.println("Il n'y a pas de bouton  numro " + i);
            return;
        }
        ((JButton)lesBoutons.get(i-1)).setEnabled(false);
    }
    
    protected void actionBouton1(){};
    protected void actionBouton2(){};
    protected void actionBouton3(){};
    protected void actionBouton4(){};
    protected void actionBouton5(){};
    protected void actionBouton6(){};
    protected void actionBouton7(){};
    protected void actionBouton8(){};
    protected void actionBouton9(){};
    protected void actionBouton10(){};
    protected void actionBouton11(){};
    protected void actionBouton12(){};
    protected void actionBouton13(){};
    protected void actionBouton14(){};
    protected void actionBouton15(){};
    protected void actionBouton16(){};
    
 /************************* La souris *************************/ 
 
    public class EcouteurSouris extends MouseAdapter implements MouseMotionListener{ // = MouseListener + mthodes dfinies (vides) par dfaut
        private MouseEvent ev = null;
        private boolean drag = false;
        
        public void mousePressed(MouseEvent e){
            ev = e;// Dbut d'un vnement MouseEvent
            boutonSouris = true;
        }
        
        public void mouseReleased(MouseEvent e){
            // on transmet les coordonnes tortue
            if (drag){
                finGlisser(tortueCourante.xEcranVersTortue(e.getX()), 
                        tortueCourante.yEcranVersTortue(e.getY()));
                ev = null;// fin de l'vnement MouseEvent
            }
            drag = false;// Fin du drag
            boutonSouris = false;
        }
        
        public void mouseClicked(MouseEvent e){
            // on transmet les coordonnes tortue
            clicSouris(tortueCourante.xEcranVersTortue(e.getX()), 
                        tortueCourante.yEcranVersTortue(e.getY()));
            ev = null;
        }
        
        public void mouseDragged(MouseEvent e){
            if (ev != null){
                debutGlisser(tortueCourante.xEcranVersTortue(e.getX()), 
                        tortueCourante.yEcranVersTortue(e.getY()));
                ev = null;// Fin de l'vnement et
                drag = true;// Dbut de drag
            }
            glisserEnCours(tortueCourante.xEcranVersTortue(e.getX()), 
                        tortueCourante.yEcranVersTortue(e.getY()));;
        }
        
        public void mouseMoved(MouseEvent e){
            sourisX = e.getX();
            sourisY = e.getY();
        }
    }

    /**Mthodes  redfinir au besoin dans les classes enfants*/    
    protected void clicSouris(double x, double y) {};
    protected void debutGlisser(double x, double y) {};
    protected void finGlisser(double x, double y) {};
    protected void glisserEnCours(double x, double y){};
    
    public void activerEvenementsSouris(){
        if (ec == null){
            ec = new EcouteurSouris();
            f.addMouseListener(ec);
            f.addMouseMotionListener(ec);
        }
    }
    
    public void desactiverEvenementsSouris(){
        if(ec != null){
            f.removeMouseListener(ec);
            f.removeMouseMotionListener(ec);
        }
        ec = null;
    }
    
    public boolean boutonSourisP(){
        return boutonSouris;
    }
    
    public int posSourisX(){
        return (int)tortueCourante.xEcranVersTortue(sourisX);//java.awt.MouseInfo.getPointerInfo().getLocation().x;
    }
    
    public int posSourisY(){
        return (int)tortueCourante.yEcranVersTortue(sourisY);
    }
// *********************** Evnements fentre *********************
    public class EcouteurFenetre extends ComponentAdapter {
        public void componentResized(ComponentEvent e){
            if (pret){
                actionTailleChange();
            }
        }
    }
    
    public void actionTailleChange(){
    }
// *********************** Pour les interruptions ******************
    
    public void permettreInterruption(boolean b){
        _interruptionPermise = b;
    }
    
    public boolean interruptionPermise(){
        return _interruptionPermise;
    }
    
//******************** Le langage tortue ****************************
    public void avance(double d){
        tortueCourante.avance(d);
    }
    
    public void av(double d){
        avance(d);
    }
    
    public void recule(double d){
        avance(-d);
    }
    
    public void re (double d){
        avance(-d);
    }
    
    public void droite(double angle){
        tortueCourante.dr(angle);
    }
    
    public void dr(double angle){
        droite(angle);
    }
    
    public void gauche(double angle){
        tortueCourante.ga(angle);
    }
    
    public void ga(double angle){
        tortueCourante.ga(angle);
    }
    
    public void couleurCrayon(Color c){
        tortueCourante.setColor(c);
    }
    
    public void cc(Color c){
        tortueCourante.setColor(c);
    }
    
    public void couleurCrayon(int r, int v, int b){
        tortueCourante.setColor(new Color(r, v, b));
    }
    
    public void cc(int r, int v, int b){
        tortueCourante.setColor(new Color(r, v, b));
    }
   /* 
    public void traceInverse(){
        tortueCourante.setModeInverse();
    }
    
    public void traceNormal(){
        tortueCourante.setModeNormal();
    }
    
    public boolean retourneModeInverse(){
        return tortueCourante.getModeInverse();
    }
    */ 
    public void tailleCrayon(double ep){
        tortueCourante.setEpaisseur(ep);
    }
    
    public void tc(double ep){
        tortueCourante.setEpaisseur(ep);
    }
    
    public double retourneTailleCrayon(){
        return tortueCourante.getEpaisseur();
    }
    
    public double retTC(){
        return tortueCourante.getEpaisseur();
    }
    
    public double cap(){
        return tortueCourante.getAngle();
    }
    
    public void fixeCap(double d){
        tortueCourante.setAngle(d);
    }
    
    public void fCap(double d){
        tortueCourante.setAngle(d);
    }
    
    public double posX(){
        return tortueCourante.getX();
    }
    
    public double posY(){
        return tortueCourante.getY();
    }
    
    public void fixePos(double x, double y){
        tortueCourante.setPos(x, y);
    }
    
    public void fPos(double x, double y){
        tortueCourante.setPos(x, y);
    }
    
    public void centreTortue(){
        fixeOrigineTortue(largeurZoneGraphique()/2, hauteurZoneGraphique()/2);
        // Forcer une mise  jour?
    }
    
    public void baisseCrayon(){
        tortueCourante.baisseCrayon();
    }
    
    public void bc(){
        baisseCrayon();
    }
    
    public void leveCrayon(){
        tortueCourante.leveCrayon();
    }
    
    public void lc(){
        leveCrayon();
    }
    
    public Color retourneCouleurCrayon(){
        return tortueCourante.getColor();
    }
    
    public int retourneCouleurCrayonR(){
        return tortueCourante.getColor().getRed();
    }
    
    public int retourneCouleurCrayonV(){
        return tortueCourante.getColor().getGreen();
    }
    
    public int retourneCouleurCrayonB(){
        return tortueCourante.getColor().getBlue();
    }
    
    public int retCCr(){
        return tortueCourante.getColor().getRed();
    }
    
    public int retCCv(){
        return tortueCourante.getColor().getGreen();
    }
    
    public int retCCb(){
        return tortueCourante.getColor().getBlue();
    }
    
    public double vers(double x, double y){
        return tortueCourante.vers(x, y);
    }
    
    public void effaceGraphique(){
        f.effacer();
    }
    
    public void videGraphique(){
        f.effacer();
        tortueCourante.init();
    }
    
    public void ecrisGraphique(double x, double y, String texte){
        // Tout en coordonnes tortue
        tortueCourante.ecrire(x, y, texte);
    }
    
    public void tailleTexteGraphique(int n){
        tortueCourante.tailleTexte(n);
    }
    
    public void tTG(int n){
        tortueCourante.tailleTexte(n);
    }
    
    public int hauteurTexteGraphique(){
        return tortueCourante.hauteurTexte();
    }
    
    public int hTG(){
        return tortueCourante.hauteurTexte();
    }
    
    public int longueurTexteGraphique(String ch){
        return tortueCourante.longueurTexte(ch);
    }
    
    public int lTG(String ch){
        return tortueCourante.longueurTexte(ch);
    }
    
    // Pour le remplissage
    public void couleurRemplissage(Color c){
        tortueCourante.setColorFill(c);
    }
    
    public void couleurRemplissage(int r, int v, int b){
        tortueCourante.setColorFill(r, v, b);
    }
    
    public Color retourneCouleurRemplissage(){
        return tortueCourante.getColorFill();
    }
 
    public int retourneCouleurRemplissageR(){
        return tortueCourante.getColorFill().getRed();
    }
    
    public int retourneCouleurRemplissageV(){
        return tortueCourante.getColorFill().getGreen();
    }
    
    public int retourneCouleurRemplissageB(){
        return tortueCourante.getColorFill().getBlue();
    }
    
    public int retCRr(){
        return tortueCourante.getColorFill().getRed();
    }
    
    public int retCRv(){
        return tortueCourante.getColorFill().getGreen();
    }
    
    public int retCRb(){
        return tortueCourante.getColorFill().getBlue();
    }
  
    public void debutRemplir(){
        tortueCourante.debutRemplir();
    }
    
    public void finRemplir(){
        tortueCourante.finRemplir();
    }
    
    public void fixeOrigineTortue(double x, double y){
        tortueCourante.setxDebut(x);
        tortueCourante.setyDebut(y);
    }
    
    public double origineTortueX(){
        return tortueCourante.getxDebut();
    }
    
    public double origineTortueY(){
        return tortueCourante.getyDebut();
    }
    
/*
 * Ajout mars 2009
 */

    public void tracePixelPoint(double x, double y, Color c){
        tortueCourante.setRGB(x, y, c);
    }
    
    public void tracePixelPoint(double x, double y, int r, int g, int b){
        tortueCourante.setRGB(x, y, r, g, b);
    }
    
    public void tracePixelPoint(double x, double y){
        tortueCourante.setRGB(x, y);
    }
    
    public Color couleurPixelPoint(double x, double y){
        return tortueCourante.getRGB(x, y);
    }
/*************** La zone graphique **********************/
    public int largeurZoneGraphique(){
        return f.getWidth();
    }
    
    public int hauteurZoneGraphique(){
        return f.getHeight();
    }
    
    public void cacherGraphique(){
        // setVisible(false) n"a aucun effet
    }
    
    public void miseAJourGraphique(){
        if (!f.macP()) {f.miseAJour();}
    }
/**************** Ecrire dans la zone de texte ***********************/
    public void ecris(String t){
        texte.append(t);
    }
    
    public void ecris(int i){
        texte.append("" + i);
    }
    
    public void ecris(double d){
        texte.append("" + d);
    }
    
    public void ecris(boolean b){
        texte.append("" + b);
    }
    
    public void ecris(Liste elem){
        texte.append(elem.toString());
    }
    
    
    public void ecrisRC(String t){// ecris avec retour de chariot
        texte.append(t + "\n");
    }
    
    public void ecrisRC(int i){// ecris avec retour de chariot
        texte.append("" + i + "\n");
    }
    
    public void ecrisRC(boolean b){
        texte.append("" + b + "\n");
    }
    
    public void ecrisRC(double d){// ecris avec retour de chariot
        texte.append("" + d + "\n");
    }
    
    public void ecrisRC(Liste elem){// ecris avec retour de chariot
        texte.append(elem.toString() + "<br>");
    }
    
    public void videTexte(){
        texte.setText("");
    }
    
    public void tailleTexte(int t){
        texte.setFont(new Font("Serif", Font.PLAIN, t));
    }
    
    public void fixeHauteurZoneTexte(int h){// h en pixels
        int hauteur = front.getSize().height - front.getInsets().top  - front.getDividerSize() - h;
        if (hauteur >0 ){
            front.setDividerLocation(hauteur);
        }else{
            fixerProportionZoneTexte(1.0);
        }
    }
    
    public void geleHauteurZoneTexte(){
        front.setResizeWeight(1.0); // le ".0" est important ici!
    }

/****************** Dessiner sans la tortue*****************************/

public void segment(double x1, double y1, double x2, double y2){
    tortueCourante.segment(x1, y1, x2, y2);
}

public void rectangleS(double x, double y, double base, double hauteur){
    tortueCourante.rectangle(x, y, base, hauteur);
}

public void rectangleC(double cx, double cy, double base, double hauteur){
    tortueCourante.rectangle(cx - base/2, cy - hauteur/2, base, hauteur);
}

public void rectangle(double x1, double y1, double x2, double y2){
    tortueCourante.rectangle(min(x1, x2), max(y1, y2), abs(x1 - x2), abs(y1 - y2));
}

public void ellipseS(double x, double y, double base, double hauteur){
    tortueCourante.ellipse(x, y, base, hauteur);
}

public void ellipseC(double cx, double cy, double base, double hauteur){
    tortueCourante.ellipse(cx - base/2, cy - hauteur/2, base, hauteur);
}

public void ellipse(double x1, double y1, double x2, double y2){
    tortueCourante.ellipse(min(x1, x2), max(y1, y2), abs(x1 - x2), abs(y1 - y2));
}

public void cercle(double cx, double cy, double rayon){
    tortueCourante.cercle(cx, cy, rayon);
}

public void arc(double cx, double cy, double rayon, double angleDeb, double angleFin){
    tortueCourante.arc(cx, cy, rayon, angleDeb, angleFin);
}

public void rectanglePleinS(double x, double y, double base, double hauteur){
    tortueCourante.rectanglePlein(x, y, base, hauteur);
}

public void rectanglePleinC(double cx, double cy, double base, double hauteur){
    tortueCourante.rectanglePlein(cx - base/2, cy - hauteur/2, base, hauteur);
}

public void rectanglePlein(double x1, double y1, double x2, double y2){
    tortueCourante.rectanglePlein(min(x1, x2), max(y1, y2), abs(x1 - x2), abs(y1 - y2));
}

public void disque(double cx, double cy, double rayon){
    tortueCourante.disque(cx, cy, rayon);
}

/***************** Divers *********************************************/    
    public void quitter(){
        dispose(); // fonctionnait mal avec threads
        if (!pourApplet){System.exit(0);}
    }
 
    public int hasard(int min, int max){
        return (int) Math.floor(min + Math.random()*(max + 1 - min));
    }
    
    public double hasard(){
        return Math.random();
    }
    
    public int valEnt(double d){
        return (int) Math.round(d); // retourne un "long"
    }
    
    public void fixeDimensions(int l, int h){// problmes
        setSize(l, h);
        repaint();
    }
    
    public void fixerProportionZoneTexte(double d){ // 0 <= d <= 1. A ne pas utiliser
        if (front != null){
            front.setDividerLocation(1 - d);
        }
    }
    
    public void fixeProportionZoneTexte(double d){ // 0 <= d <= 1
        if (d < 0){d = 0;}
        if (d > 1) {d = 1;}
        if (front != null){
            front.setDividerLocation(1 - d);
        }
    }

    public void attendre(int x){
        
        Thread t = Thread.currentThread();
        try{
            //t.sleep(x);
            Thread.sleep((long)x);
        }catch (InterruptedException e){
        }
    }
    
    // construire une couleur  partir des composantes RGB
    public Color couleurRVB(int r, int v, int b){
        return new Color(r, v, b);
    }
    
    public void bip(){
        Toolkit.getDefaultToolkit().beep();
    }
   
    public static String unicode(String ch){
        return Unicode.coder(ch);
    }
    
    public boolean egalesP(String ch1, String ch2){
        return ch1.equals(ch2);
    }
    
    public int divEnt(int a, int b){
        return a/b;
    }
    
    public double divDec(double a, double b){
        return a/b;
    }
    
    public int mod(int a, int b){
        return a % b;
    }
    
    public static boolean appletP(){
        return pourApplet;
    }
    
    public static void faireApplet(boolean b){
        pourApplet = b;
    }
    
    public double valDec(int a){
        return (double) a;
    }
    
    public String chaine(Liste l){
        return l.toString();
    }
    
    public String chaine(int n){
        return "" + n;
    }
    
    public String chaine(double d){
        return "" + d;
    }
    
    public String chaine(double d, int n){
        String ch = "" + arrondis(d,n);
        int posPoint = ch.indexOf(".");
        // si la position est -1 ajouter . et n zros
        if (posPoint == -1){
            ch += ".";
            for(int i = 0; i< n; i++){
                ch += "0";
            }
            return ch;
        }
        // sinon ajouter n - (ch.length() - pos.) + 1 zros
        int nbZeros = n - ch.length() + posPoint + 1;
        for(int i = 0; i < nbZeros; i++){
                ch += "0";
            }
        return ch;
    }
    
    public String chaine(Liste l, int n){
        if (l instanceof Entier){
            return chaine(l.valEntier(), n);
        }
        if (l instanceof Decimal){
            return chaine(l.valDecimale(), n);
        }
        return chaine(l);
    }
    
    public String remplacer(String ch, String ancienCar, String nouveauCar){
        return ch.replace(ancienCar, nouveauCar);
    }

/***************** Dialogues ***************************/
    
    private void setAnnulation(boolean b){
        demandeAnnulation = b;
    }
    
    public boolean annulation(){
        return demandeAnnulation;
    }
    
    public int demanderEntier(String titre, String message, int valInit){
        setAnnulation(false);
        String resultat = "";
        int valeurResultat = 0;
        boolean echec = true;
        while(echec){
            echec = false;
            JOptionPane fen = new JOptionPane(message, JOptionPane.QUESTION_MESSAGE);
            fen.selectInitialValue();
            String[] options = {"OK"};
            fen.setOptions(options);
            resultat = (String)fen.showInputDialog(this, message, titre, JOptionPane.QUESTION_MESSAGE, null, null, "" + valInit);
            if (resultat == null){
                setAnnulation(true);
                return entMin;
            }
            try{
                valeurResultat = Integer.parseInt(resultat);
            }
            catch(Exception e){
                echec = true;
            }
        }
        return valeurResultat;
    }
    
    public int demanderEntier(String titre, String message){
        return demanderEntier(titre, message, 1);
    }
    
    public double demanderNombre(String titre, String message, double valInit){
        setAnnulation(false);
        String resultat = "";
        double valeurResultat = 0;
        boolean echec = true;
        while(echec){
            echec = false;
            JOptionPane fen = new JOptionPane(message, JOptionPane.QUESTION_MESSAGE);
            fen.selectInitialValue();
            String[] options = {"OK"};
            fen.setOptions(options);
            resultat = (String)fen.showInputDialog(this, message, titre, JOptionPane.QUESTION_MESSAGE, null, null, "" + valInit);
            if (resultat == null){
                setAnnulation(true);
                return decMin;
            }
            try{
                valeurResultat = Double.parseDouble((String)(resultat));
            }
            catch(Exception e){
                echec = true;
            }
        }
        return valeurResultat;
    }
    
    public double demanderNombre(String titre, String message){
        return demanderNombre(titre, message, 1.0);
    }
    
    public String demanderChaine(String titre, String message, String valInit){
        setAnnulation(false);
        String resultat = "";
        JOptionPane fen = new JOptionPane(message, JOptionPane.QUESTION_MESSAGE);
        fen.selectInitialValue();
        String[] options = {"OK"};
        fen.setOptions(options);
        resultat = fen.showInputDialog(message, valInit);
        if (resultat == null){
                setAnnulation(true);
                return null;
        }
        return resultat;
    }
    
    public String demanderChaine(String titre, String message){
        return demanderChaine(titre, message, "?");
    }
    
    public int choixMultiple(String titre, String question, String bouton1, String bouton2, String bouton3, String bouton4){
        int resultat;
        setAnnulation(false);
        String[] nomsBoutons = new String[4];
        nomsBoutons[0] = bouton1;
        nomsBoutons[1] = bouton2;
        nomsBoutons[2] = bouton3;
        nomsBoutons[3] = bouton4;
        resultat = JOptionPane.showOptionDialog(this, question, titre, JOptionPane.YES_NO_OPTION ,
                                                JOptionPane.QUESTION_MESSAGE, null, nomsBoutons, nomsBoutons[0]);
        if (resultat == -1){setAnnulation(true);}
        return resultat+1;
    }
    
    public int choixMultiple(String titre, String question, String bouton1, String bouton2, String bouton3){
        int resultat;
        String[] nomsBoutons = new String[3];
        nomsBoutons[0] = bouton1;
        nomsBoutons[1] = bouton2;
        nomsBoutons[2] = bouton3;
        resultat = JOptionPane.showOptionDialog(this, question, titre, JOptionPane.YES_NO_OPTION ,
                                                JOptionPane.QUESTION_MESSAGE, null, nomsBoutons, nomsBoutons[0]);
        return resultat+1;
    }
    
    public int choixMultiple(String titre, String question, String bouton1, String bouton2){
        int resultat;
        String[] nomsBoutons = new String[2];
        nomsBoutons[0] = bouton1;
        nomsBoutons[1] = bouton2;
        resultat = JOptionPane.showOptionDialog(this, question, titre, JOptionPane.YES_NO_OPTION ,
                                                JOptionPane.QUESTION_MESSAGE, null, nomsBoutons, nomsBoutons[0]);
        return resultat+1;
    }
    
    public int choixMultiple(String titre, String question, String bouton1){
        int resultat;
        String[] nomsBoutons = new String[1];
        nomsBoutons[0] = bouton1;
        resultat = JOptionPane.showOptionDialog(this, question, titre, JOptionPane.YES_NO_OPTION ,
                                                JOptionPane.QUESTION_MESSAGE, null, nomsBoutons, nomsBoutons[0]);
        return resultat+1;
    }
    
    public void message(String mes){
        JOptionPane.showMessageDialog(this, mes, "Message", JOptionPane.INFORMATION_MESSAGE);
    }
   
/********************** Les fichiers *********************************/

public void sauverDonnees(){
    try{
        fichiers.sauverDonnees("Donnez le nom du fichier  enregistrer et ouvrez le dossier destination.");
    }catch (IOException e){
        System.out.println("Problme pour l'enregistrement du fichier!");
    }
    fichiers.viderDonneesASauver();
}

public void lireFichier(){
    fichiers.viderDonneesLues();
    try{
        fichiers.lireFichier("Donnez le nom du fichier  lire");
    }catch (IOException e){
        System.out.println("Problme pour la lecture du fichier!");
    }
}

public void ajouterDonnee(String donnee){
    fichiers.ajouterDonnee(donnee);
}

public void ajouterDonnee(int donnee){
    fichiers.ajouterDonnee("" + donnee);
}

public void ajouterDonnee(double donnee){
    fichiers.ajouterDonnee("" + donnee);
}

public void ajouterDonnee(boolean donnee){
    fichiers.ajouterDonnee("" + donnee);
}

public String lireDonnee(int i){
    return fichiers.lireDonnee(i);
}

public String lireDonneeSuivante(){
    return fichiers.lireDonneeSuivante();
}

public void viderDonneesASauver(){
    fichiers.viderDonneesASauver();
}

public void viderDonneesRamenees(){
    fichiers.viderDonneesLues();
}

public int tailleFichier(){
    return fichiers.tailleDonneesLues();
}
    
public void rembobiner(){
    fichiers.rembobiner();
}
    
public int valEnt(String donnee){
    int resultat = 0;
    try{
        resultat = Integer.parseInt(donnee);
    }catch (NumberFormatException e){
        System.out.println("Impossible de convertir " + donnee + " en entier!");
        System.exit(1);
    }
    return resultat;
} 

public double valDec(String donnee){
    double resultat = 0;
    try{
        resultat = Double.parseDouble(donnee);
    }catch (NumberFormatException e){
        System.out.println("Impossible de convertir " + donnee + " en dcimal!");
        System.exit(1);
    }
    return resultat;
} 

public boolean valBool(String donnee){
    boolean resultat = Boolean.valueOf(donnee).booleanValue();
    return resultat;
}

public boolean existeFichier(String nom){
    File fich = new File(nom);
    return fich.exists();
}

/***************** Langage des listes *********************************/
 // Cration
    public Liste listeVide(){return new Liste();}
    public Liste vecteurVersListe(int[] tab){return new Liste(tab);}
    public Liste vecteurVersListe(double[] tab){return new Liste(tab);}
    public Liste vecteurVersListe(boolean[] tab){return new Liste(tab);}
    public Liste vecteurVersListe(String[] tab){return new Liste(tab);}
// Ajout d'lments au dbut
    // Version non destructive
    public Liste metsPremier(int i, Liste L) {
        Liste x = clone(L);
        x.fPut(i);
        return x;
    }
    public Liste metsPremier(double d, Liste L) {
        Liste x = clone(L);
        x.fPut(d);
        return x;
    }
    public Liste metsPremier(String ch, Liste L) {
        Liste x = clone(L);
        x.fPut(ch);
        return x;
    }
    public Liste metsPremier(boolean b, Liste L) {
        Liste x = clone(L);
        x.fPut(b);
        return x;
    }
    public Liste metsPremier(Liste l, Liste L) {
        Liste x = clone(L);
        x.fPut(l.cloner());
        return x;
    }
    
    public Liste mp(int i, Liste L){return metsPremier(i, L);}
    public Liste mp(double d, Liste L){return metsPremier(d, L);}
    public Liste mp(String s, Liste L){return metsPremier(s, L);}
    public Liste mp(boolean b, Liste L){return metsPremier(b, L);}
    public Liste mp(Liste l, Liste L){return metsPremier(l, L);}
    // Version destructive
    public Liste fPut(int i, Liste L) {L.fPut(i); return L;}
    public Liste fPut(double d, Liste L){ L.fPut(d);return L;}
    public Liste fPut(String s, Liste L){L.fPut(s);return L;}
    public Liste fPut(boolean b, Liste L){L.fPut(b);return L;}
    public Liste fPut(Liste l, Liste L){L.fPut(l);return L;}
// Ajout d'lments a la fin
    // Version non destructive
    public Liste metsDernier(int i, Liste L){
        Liste x = L.cloner();
        x.lPut(i);
        return x;
    }
    public Liste metsDernier(double d, Liste L){
        Liste x = L.cloner();
        x.lPut(d);
        return x;
    }
    public Liste metsDernier(String s, Liste L){
        Liste x = L.cloner();
        x.lPut(s);
        return x;
    }
    public Liste metsDernier(boolean b, Liste L){
        Liste x = L.cloner();
        x.lPut(b);
        return x;
    }
    public Liste metsDernier(Liste l, Liste L){
        Liste x = L.cloner();
        x.lPut(l.cloner());
        return x;
    }
    
    public Liste md(int i, Liste L){return metsDernier(i, L);}
    public Liste md(double d, Liste L){return metsDernier(d, L);}
    public Liste md(String s, Liste L){return metsDernier(s, L);}
    public Liste md(boolean b, Liste L){return metsDernier(b, L);}
    public Liste md(Liste l, Liste L){return metsDernier(l, L);}
    // Version destructive
    public Liste lPut(int i, Liste L){L.lPut(i);return L;}
    public Liste lPut(double d, Liste L){L.lPut(d);return L;}
    public Liste lPut(String s, Liste L){L.lPut(s);return L;}
    public Liste lPut(boolean b, Liste L){L.lPut(b);return L;}
    public Liste lPut(Liste l, Liste L){L.lPut(l);return L;}
    
// Ajout d'lments a un indice donn
    // Version non destructive
    public Liste insereItem(int i, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemPut(i, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'insreItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste insereItem(double d, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemPut(d, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'insreItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste insereItem(boolean b, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemPut(b, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'insreItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste insereItem(String s, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemPut(s, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'insreItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste insereItem(Liste l, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemPut(l.cloner(), index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'insreItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    
    // Version destructive
    public Liste itemPut(int i, int index, Liste L){
        try{
            L.itemPut(i, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'itemPut' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste itemPut(double d, int index, Liste L){
        try{
            L.itemPut(d, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'itemPut' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste itemPut(boolean b, int index, Liste L){
        try{
            L.itemPut(b, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'itemPut' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste itemPut(String s, int index, Liste L){
        try{
            L.itemPut(s, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'itemPut' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste itemPut(Liste l, int index, Liste L){
        try{
            L.itemPut(l, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'itemPut' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    
// Remplacer l'item  un indice donn
    // Version non destructrive
    public Liste remplaceItem(int i, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemRemplace(i, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'remplaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste remplaceItem(double d, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemRemplace(d, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'remplaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste remplaceItem(boolean b, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemRemplace(b, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'remplaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste remplaceItem(String s, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemRemplace(s, index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'remplaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste remplaceItem(Liste l, int index, Liste L){
        try{
            Liste x = L.cloner();
            x.itemRemplace(l.cloner(), index);
            return x;
        }
        catch (ListException e){
            System.out.println("Problme dans 'remplaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    
// Version destructrive
    public Liste replaceItem(int i, int index, Liste L){
        try{
            L.itemRemplace(i, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'remplaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste replaceItem(double d, int index, Liste L){
        try{
            L.itemRemplace(d, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'replaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste replaceItem(boolean b, int index, Liste L){
        try{
            L.itemRemplace(b, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'replaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste replaceItem(String s, int index, Liste L){
        try{
            L.itemRemplace(s, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'replaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    public Liste replaceItem(Liste l, int index, Liste L){
        try{
            L.itemRemplace(l, index);
            return L;
        }
        catch (ListException e){
            System.out.println("Problme dans 'replaceItem' :");
            System.out.println(e);
            System.exit(1);
        }
        return null;
    }
    
// Lecture
    public Liste premier(Liste L){
        try{
            return L.first().cloner();
        }
        catch(ListException e){
            System.out.println("Problme dans 'first' :");
            System.out.println(e);
            System.exit(1);
            return new Entier(1);
        } 
    }
    
    public Liste pr(Liste L){
        try{
            return L.first().cloner();
        }
        catch(ListException e){
            System.out.println("Problme dans 'first' :");
            System.out.println(e);
            System.exit(1);
            return new Entier(1);
        } 
    }
    
    public Liste dernier(Liste L){
        try{
            return L.last().cloner();
        }
        catch(ListException e){
            System.out.println("Problme dans 'last' :");
            System.out.println(e);
            System.exit(1);
            return new Entier(1);
        }
    }
    
    public Liste de(Liste L){
        try{
            return L.last().cloner();
        }
        catch(ListException e){
            System.out.println("Problme dans 'last' :");
            System.out.println(e);
            System.exit(1);
            return new Entier(1);
        }
    }
    
    public Liste item(int index, Liste L){
        try{
            return L.item(index).cloner();
        }
        catch(ListException e){
            System.out.println("Problme dans 'last' :");
            System.out.println(e);
            System.exit(1);
            return new Entier(1);
        }
    }
// Suppression
    // Version non destructive
    public Liste saufPremier(Liste L){
        try{
            Liste x = L.cloner();
            return x.butFirst();
        }
        catch(ListException e){
            System.out.println("Problme dans 'saufPremier' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
    
    public Liste sp(Liste L){
        try{
            Liste x = L.cloner();
            return x.butFirst();
        }
        catch(ListException e){
            System.out.println("Problme dans 'sp' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
    
    public Liste saufDernier(Liste L){
        try{
            Liste x = L.cloner();
            return x.butLast();
        }
        catch(ListException e){
            System.out.println("Problme dans 'saufDernier' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
    
    public Liste sd(Liste L){
        try{
            Liste x = L.cloner();
            return x.butLast();
        }
        catch(ListException e){
            System.out.println("Problme dans 'sd' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
    
    public Liste supprimerItem(int index, Liste L){
        try{
            Liste x = L.cloner();
            return x.butItem(index);
        }
        catch(ListException e){
            System.out.println("Problme dans 'supprimerItem' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
    // Version destructive
        public Liste butFirst(Liste L){
        try{
            return L.butFirst();
        }
        catch(ListException e){
            System.out.println("Problme dans 'butFirst' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }

    public Liste butLast(Liste L){
        try{
            return L.butLast();
        }
        catch(ListException e){
            System.out.println("Problme dans 'butLast' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
    
    public Liste butItem(int index, Liste L){
        try{
            return L.butItem(index);
        }
        catch(ListException e){
            System.out.println("Problme dans 'butItem' :");
            System.out.println(e);
            System.exit(1);
            return null;
        }
    }
// Les prdicats
    public boolean entierP(Liste elem){return elem.entierP();}
    public boolean decimalP(Liste elem){return elem.decimalP();}
    public boolean nombreP(Liste elem){return elem.nombreP();}
    public boolean chaineP(Liste elem){return elem.chaineP();}
    public boolean booleenP(Liste elem){return elem.booleenP();}
    public boolean listeP(Liste elem){return elem.listeP();}
    public boolean videP(Liste l){return l.emptyP();}
    public boolean elementP(int i, Liste L){return L.memberP(i);}
    public boolean elementP(double d, Liste L){return L.memberP(d);}
    public boolean elementP(boolean b, Liste L){return L.memberP(b);}
    public boolean elementP(Chaine ch, Liste L){return L.memberP(ch);}
    public boolean elementP(Liste l, Liste L){return L.memberP(l);}
// Divers
    public int compte(Liste L){return L.count();}
    public Liste clone(Liste L){return L.cloner();}
    // Version non destructive
    public Liste phrase(Liste l1, Liste l2){
        Liste x = l1.cloner();
        x.sentence(l2.cloner());
        return x;
    }
    // Version destructive
    public Liste sentence(Liste l1, Liste l2){l1.sentence(l2); return l1;}
    // Retourne le type d'un lment: 1 = entier, 2 = double, 3 = chaine, 4 = Liste
    public int type(Liste elem){return elem.getType();}
    
    public int valEnt(Liste elem){
        return elem.valEntier();
    }
    
    public double valDec(Liste elem){
        return elem.valDecimale();
    }
    
    public String valChaine(Liste elem){
        return elem.valChaine();
    }
    
    public boolean valBool(Liste elem){
        return elem.valBool();
    }
/******************* Les fonctions mathmatiques*************************/

    public double E = Math.E;
    public double Pi = Math.PI;
    
    public double abs(double x){
        return Math.abs(x);
    }
    
    public int abs(int x){
        return Math.abs(x);
    }
    
    public double acos(double x){
        return Math.acos(x);
    }
    
    public double asin(double x){
        return Math.asin(x);
    }
    
    public double atan(double x){
        return Math.atan(x);
    }
    
    public double atan2(double x, double y){
        return Math.atan2(x, y);
    }
    
    public int plafond(double x){
        return (int) Math.ceil(x);
    }
    
    public double plafond(double x, int n){
        if (n <= 0){return Math.ceil(x);}
        double facteur = Math.pow(10, n);
        return Math.ceil(x * facteur)/facteur;
    }
    
    public double cos(double x){
        return Math.cos(x);
    }
    
    public double exp(double x){
        return Math.exp(x); // E^x
    }
    
    public int plancher(double x){
        return (int)Math.floor(x);
    }
    
    public double plancher(double x, int n){
        if (n <= 0){return Math.floor(x);}
        double facteur = Math.pow(10, n);
        return Math.floor(x * facteur)/facteur;
    }
    
    public double log(double x){
        return Math.log(x); // base E
    }
    
    public double max(double x, double y){
        return Math.max(x, y);
    }
    
    public int max(int x, int y){
        return Math.max(x, y);
    }
    
    public double min(double x, double y){
        return Math.min(x, y);
    }
    
    public int min(int x, int y){
        return Math.min(x, y);
    }
    
    public double pow(double x, double y){
        return Math.pow(x, y);
    }
    
    public double puissance(double x, double y){
        return Math.pow(x, y);
    }
    
    public int arrondis(double x){// Si le double est trop grand le retour devrait tre un long
        return (int) Math.round(x);
    }
    
    public double arrondis(double x, int n){
        if (n <= 0){return arrondis(x);}
        double facteur = Math.pow(10, n);
        return arrondis(x * facteur)/(double) facteur;
    }
    
    public double sin(double x){
        return Math.sin(x);
    }
    
    public double sqrt(double x){
        return Math.sqrt(x);
    }
    
    public double racine(double x){
        return Math.sqrt(x);
    }
    
    public double tan(double x){
        return Math.tan(x);
    }
    
    public double sinD(double x){// x en degrs
        return Math.sin(Math.toRadians(x));
    }
    
    public double cosD(double x){// x en degrs
        return Math.cos(Math.toRadians(x));
    }
    
    public double tanD(double x){// x en degrs
        return Math.tan(Math.toRadians(x));
    }
    
    public double asinD(double x){
        return Math.toDegrees(Math.asin(x));
    }
    
    public double acosD(double x){
        return Math.toDegrees(Math.acos(x));
    }
    
    public double atanD(double x){
        return Math.toDegrees(Math.atan(x));
    }
    
    public double atan2D(double x, double y){
        return Math.toDegrees(Math.atan2(x, y));
    }
    
    // Numro de version
    public void versionExpresso(){
        String mess=unicode("Expresso");
        mess += "\nversion " + version;
        message(mess);
    }
    
    // Intgration de JEP
    
    public Expression analyse(String chaine)
    {
        return new Expression(chaine);   
    }
    
    public void var(Expression formule, String nom, double val)
    {
           formule.valeur(nom,val);
    }
    
    public double valVar(Expression formule, String nom)
    {
           return formule.valeurVar(nom);
    }
    
    public double eval(Expression formule)
    {
           return formule.eval();
    }
    
    public double eval(Expression formule,double x)
    {
           return formule.eval(x);
    }
    
    public int posErreur(Expression formule)
    {
            return formule.posErreur();
    }
    
//********************* Ajout 3 et 5 dcembre 2008 ********************

    public String[] nomsDesVariables(Expression formule){
        return formule.nomsDesVariables();
    }
    
    public int nbDeVariables(Expression formule){
        return formule.nbDeVariables();
    }
    
    public boolean existeVar(Expression formule, String nom){
        return formule.isVar(nom);
    }
    
    public void ajouteVar(Expression formule, String nom, double val){
        if (! formule.isVar(nom)) {formule.addVar(nom, val);}
    }
    
    public void ajouteVar(Expression formule, String nom){
        if (! formule.isVar(nom)) {formule.addVar(nom, 0);}
    }
    
    public String expressionDefinissante(Expression formule) {
        return formule.chaineOriginale();
    }

//************ Ajouts juillet et novembre 2009 ****************
// Modifi Juillet 2011

    public ImageMemoire chargerImage(String nom){
        ImageMemoire img;
        ImageChargeur chargeur = new ImageChargeur(this);
        img = chargeur.chargerUneImage(nom);
        return img;
    }

    public ImageMemoire chargerImageFD(){ // FD = fenetre de dialogue
        String nomFichier = fichiers.trouverNomFichierImage("Choisissez l'image  ramener", false);
        if (nomFichier == null){return null;}
        return chargerImage(nomFichier);
    }
    
    public ImageMemoire chargerImageWeb(String adresse){
        BufferedImage img = null;
        URL fich = null;
        try{
            fich = new URL(adresse);
            URLConnection fc = fich.openConnection();
            fc.connect();
        }catch(Exception e){
            ecris("Problmes pour tablir la connection");
            return null;
        }
        try {
             img = ImageIO.read(fich);
         } catch (IOException e) {
             ecris("problmes");
             return null;
         }
         return new ImageMemoire(img);
    }
    
    public ImageMemoire chargerImageWeb(){
        BufferedImage img = null;
        String adresse = demanderChaine("Adresse","Donnez l'adresse de l'image  charger");
        if (annulation()){return null;}
        return chargerImageWeb(adresse);
    }
    public void afficherImage(ImageMemoire img, double x, double y, double l, double h){
        if (img == null){return;}
        tortueCourante.afficherImage(img.image, x, y, l, h);
    }
    
    public void enregistrerImageEcran(String nomFichier, double x, double y, double l, double h){
        if (pourApplet){return;}
        tortueCourante.sauverImage(nomFichier, x, y, l, h);
    }

   public void enregistrerImage(String nomFichier, ImageMemoire imag){
       if (pourApplet){return;}
        File fichier = new File(nomFichier+".png");
        try{
            javax.imageio.ImageIO.write(imag.image, "png", fichier);
        }catch(IOException e){System.out.println("Problmes en enregistrant " + fichier);}
    }
    
    public void enregistrerImageFD(ImageMemoire imag){
        if (pourApplet){return;}
        String nomFichier = fichiers.trouverNomFichierImage(
                            "Slectionnez l'endroit o sauver et donnez le nom du fichier",
                            true);
        if (nomFichier == null){return;}
        String ext = "png";
        int i = nomFichier.lastIndexOf(".");
        if (i == -1){
            nomFichier = nomFichier + "." + ext;
        }else{
            if (nomFichier.length() == i+1){
                nomFichier = nomFichier + ext;
            }else{
                ext = nomFichier.substring(i+1);
                if ((ext.compareTo("jpg") != 0) && (ext.compareTo("gif") != 0) && (ext.compareTo("png") != 0)){
                    return;
                }
            }
        }
        File fichier = new File(nomFichier);
        try{
            javax.imageio.ImageIO.write(imag.image, ext, fichier);
        }catch(IOException e){ecris("Problmes en enregistrant " + nomFichier);}
    }
    
    public ImageMemoire copierImageEcran(double x, double y, double l, double h){
        BufferedImage img =  tortueCourante.copierImage(x, y, l, h);
        if (img == null){
            ecris("problmes en copiant");
            return null;
        }
        return new ImageMemoire(img); 
    }
    // copie une partie d'une image en mmoire utilise les coordonnes internes de l'image
    public ImageMemoire copierImage(ImageMemoire img, int x, int y, int l, int h){
        BufferedImage imag = null;
        x = Math.max(x,0);
        x = Math.min(x, img.image.getWidth());
        y = Math.max(y,0);
        y = Math.min(y, img.image.getHeight());
        try{
            imag = img.image.getSubimage(x, y, l, h);
            return new ImageMemoire(imag);
        }catch (Exception e){
            ecris("Problmes en copiant");
            return null;
        }
    }
    
    public int largeurImage(ImageMemoire img){
        if (img.image != null){
            return img.image.getWidth();
        }else{
            return 0;
        }
    }
    
    public int hauteurImage(ImageMemoire img){
        if (img.image != null){
            return img.image.getHeight();
        }else{
            return 0;
        }
    }
    
    // Modification trace inverse
    
    public void traceInverse(){
        f.gTampon.setXORMode(Color.white);
    }
    
    public void traceNormal(){
        f.gTampon.setPaintMode();
    }
    
//******* Ajout 17/02/2010

    public boolean executionLocale(){
        return !pourApplet;
    }
    
// *******Ajout 18 septembre 2012

    public String valeurChamp(int i){
        if (i < 1){ return "";}
        if( i > lesChamps.size()) { return "";}
        return ((CTexte) lesChamps.get(i-1)).valeur;
    }
    
    public void fixeValeurChamp(int i, String val){
        if (i < 1){ return;}
        if( i > lesChamps.size()) { return;}
        ((CTexte) lesChamps.get(i-1)).setText(val);
        ((CTexte) lesChamps.get(i-1)).valeur=val;
    }
 
   
}
