package Listes;

public class Decimal extends Liste{
    private double valeur;
    
    public Decimal(double d){
        valeur = d;
        type = 2;
    }
    
    public double valDecimale(){
        return valeur;
    }
    
    public int valEntier(){
        return (int) Math.round(valeur);
    }
    
    public String toString(){
        return "" + valeur;
    }
    
    public boolean equals(Object obj){
        if (! (obj instanceof Liste)){return false;}
        Liste elem = (Liste)obj;
        if (elem.getType() > 2){return false;}
        return valDecimale() == elem.valDecimale();
    }
    
    public Liste cloner(){
        return new Decimal(valeur);
    }
}